# `font-style` CSS Property <sup>standard name</sup>

## Summary

Set the `italic` style of the font for an element.

## Details

* values: `normal`, `italic`
* default value: `normal`
* apply to: `<text>`, `<input>`

## Compares with CSS Standard

* The effect not apply to all elements, just `<text>` and `<input>`. In another way, it's not inherited.

## Example

```html
<template>
  <div>
    <text style="font-style: italic;">Hello World</text>
  </div>
</template>
```
