# `opacity` CSS Property <sup>standard name</sup>

## Summary

The transparency degree to an element and its children. `1` means fully opaque, `0` means fully transparent.

## Details

* type: [number](units/number.md)
* range: `0` ~ `1`
* default value: `1`
* apply to: all elements

## Example

```html
<template>
  <div style="opacity: 0.8; background-color: green;">
    <text>Hello World</text>
  </div>
</template>
```
